<?php
/*
* THIS FILE HAVE SOME RESTRICTIONS. GET MORE INFO HERE: read-me.txt
*/

// START OF PLUGIN LICENSE RESTRICTIONS - GET MORE INFO HERE: read-me.txt
/**
* Save to cookie last visited products
* @return void
* @param int  $iProduct
*/
function addProductsVisit( $iProduct ){
  if( isset( $_SESSION['aVisitedProducts'] ) ){
    if( in_array( $iProduct, $_SESSION['aVisitedProducts'] ) ){
      foreach( $_SESSION['aVisitedProducts'] as $iKey => $iValue ){
        if( $iProduct == $iValue ){
          unset( $_SESSION['aVisitedProducts'][$iKey] );
        }
      }
    }

    if( end( $_SESSION['aVisitedProducts'] ) != $iProduct ){
      $_SESSION['aVisitedProducts'][] = $iProduct;
    }
  }
  else{
    $_SESSION['aVisitedProducts'][] = $iProduct;
  }
} // end function addProductsVisit

/**
* Display last viesited products
* @return string
* @param string $sFile
*/
function listLastVisitedProducts( $sFile ){
  if( isset( $_SESSION['aVisitedProducts'] ) && count( $_SESSION['aVisitedProducts'] ) > 1 ){
    $oTpl = TplParser::getInstance( );
    $oFile = Files::getInstance( );
    $oProduct = Products::getInstance( );

    $iColumns = 3;
    $i2 = 0;
    $iWidth = (int) ( 100 / $iColumns );
    $content = null;

    $aProducts = array_reverse( $_SESSION['aVisitedProducts'] );
    $iCount = count( $aProducts );
    if( $iCount > 4 )
      $iCount = 4;
    
    for( $i = 1; $i < $iCount; $i++ ){
      $aData = $oProduct->aProducts[$aProducts[$i]];
      $aData['iWidth'] = $iWidth;
      $aData['iStyle'] = ( $i % 2 ) ? 0 : 1;

      $oTpl->setVariables( 'aData', $aData );
      if( isset( $oFile->aImagesDefault[2][$aData['iProduct']] ) ){
        $aDataImage = $oFile->aFilesImages[2][$oFile->aImagesDefault[2][$aData['iProduct']]];
        $oTpl->setVariables( 'aDataImage', $aDataImage );
        $oTpl->setIf( 'IMAGE' );
      }

      $aData['sPrice'] = is_numeric( $aData['mPrice'] ) ? displayPrice( $aData['mPrice'] ) : $aData['mPrice'];
      $oTpl->setVariables( 'aData', $aData );

      if( is_numeric( $aData['mPrice'] ) ){
        $oTpl->setIf( 'PRICE' );
      }
      else
        $oTpl->setIf( 'NO-PRICE' );

      $oTpl->setVariables( 'aData', $aData );
      $content .= $oTpl->tSubBlock( $sFile, 'LAST-VISITED', 'LIST' );
      $i2++;
    } // end for

    while( $i2 % $iColumns > 0 ){
      $content .= $oTpl->tBlock( $sFile, 'LAST-VISITED-BLANK' );
      $i2++;
    } // end while

    if( !empty( $content ) )
      return $oTpl->tSubBlock( $sFile, 'LAST-VISITED', 'LIST', 'head' ).$content.$oTpl->tSubBlock( $sFile, 'LAST-VISITED', 'LIST', 'foot' );
  }
} // end function listLastVisitedProducts

/**
* Count visits and display
* @return array
*/
function simpleCounter( ){
  if( is_file( DB_COUNTER ) ){    
    $aFile = file( DB_COUNTER );
    if( isset( $aFile[1] ) && !empty( $aFile[1] ) ){
      $aExp = explode( '$', $aFile[1] );
      $sDate = date( 'Y-m-d' );
      $aVisits[0] = $aExp[0];
      $aVisits[1] = ( !empty( $aExp[2] ) && $aExp[2] == $sDate ) ? $aExp[1] : 0;
    }

    if( !preg_match('/'.$GLOBALS['config']['disable_agents'].'|^$/i', $_SERVER['HTTP_USER_AGENT'] ) && !isset( $_COOKIE['simpleCounter'] ) ){
      $sSave = '<?php exit; ?>'."\n";
      $rFile = fopen( DB_COUNTER, 'r+' );
      if( isset( $aVisits ) ){
        $aVisits[0]++;
        $aVisits[1]++;
      }
      else{
        $aVisits = Array( 1, 1 );
      }

      fwrite( $rFile, $sSave.$aVisits[0].'$'.$aVisits[1].'$'.date( 'Y-m-d' ).'$'."\n" );
      fclose( $rFile );
      setcookie( 'simpleCounter', true, time( ) + 7200 );
    }

    if( isset( $aVisits ) )
      return $aVisits;
    else
      return Array( 1, 1 );
  }
} // end function simpleCounter

/**
* List bestsellers sorted by quantity
* @return string
* @param string $sFile
*/
function listSimpleBestsellers( $sFile ){
  $iLimit = 3; // limit of products in the list in simple bestsellers box

  $sLang = strtolower( LANGUAGE );
  $rFile = fopen( DB_ORDERS, 'r' );
  $i = 0;
  while( !feof( $rFile ) ){
    $sContent = fgets( $rFile );
    if( $i > 0 && !empty( $sContent ) ){
      $aData = unserialize( trim( $sContent ) );
      if( $aData['sLanguage'] == $sLang )
        $aOrdersLang[$aData['iOrder']] = true;
    }
    $i++;
  } // end while
  fclose( $rFile );

  if( isset( $aOrdersLang ) ){
    $oProduct = Products::getInstance( );
    $rFile = fopen( DB_ORDERS_PRODUCTS, 'r' );
    $i = 0;
    while( !feof( $rFile ) ){
      $sContent = fgets( $rFile );
      if( $i > 0 && !empty( $sContent ) ){
        $aData = unserialize( trim( $sContent ) );
        if( isset( $aOrdersLang[$aData['iOrder']] ) && isset( $oProduct->aProducts[$aData['iProduct']] ) ){
          if( !isset( $aProducts[$aData['iProduct']] ) ){
            $aProducts[$aData['iProduct']] = Array( 0, $aData['iProduct'] );
          }
          $aProducts[$aData['iProduct']][0] += $aData['iQuantity'];
        }
      }
      $i++;
    } // end while
    fclose( $rFile );
  }
  
  if( isset( $aProducts ) ){
    rsort( $aProducts );
    $iCount = count( $aProducts );
    if( $iCount >= $iLimit )
      $iCount = $iLimit; 
    
    for( $i = 0; $i < $iCount; $i++ ){
      $aReturn[] = $aProducts[$i][1];
    } // end for

  }
  if( isset( $aReturn ) ){
    return $oProduct->listProducts( $sFile, null, $iCount, $aReturn, 'SIMPLE-BESTSELLERS' );
  }
} // end function listSimpleBestsellers

/**
* Get link from url and change it to new
* @return string
*/
function getLinkFromShortLinks( ){
  require_once $GLOBALS['config']['dir_libraries'].'file-jobs.php';
  require_once $GLOBALS['config']['dir_libraries'].'flat-files.php';
  $oFFS = FlatFilesSerialize::getInstance( );
  $aShortLinks = $oFFS->getData( DB_LINKS, true );
  if( isset( $aShortLinks ) && is_array( $aShortLinks ) && count( $aShortLinks ) > 0 ){
    if( isset( $_GET ) && is_array( $_GET ) ){
      $aKeys = array_keys( $_GET );
      if( isset( $aKeys[0] ) && isset( $aShortLinks[$aKeys[0]] ) ){
        $aData = $_GET;
        foreach( $aData as $sKey => $sValue ){
          if( $aKeys[0] == $sKey ){
            if( $aShortLinks[$aKeys[0]]['iType'] == 2 )
              $sReplace = $aShortLinks[$aKeys[0]]['iLink'].','.$aKeys[0];
            else
              $sReplace = $aKeys[0].','.$aShortLinks[$aKeys[0]]['iLink'];
            $aNew[$sReplace] = '';
            //$_SERVER['REQUEST_URI'] = str_replace( '?'.$aKeys[0], '?'.$sReplace, $_SERVER['REQUEST_URI'] );
            $sReturn = $aShortLinks[$aKeys[0]]['sLang'];
          }
          else
            $aNew[$sKey] = $sValue;
        } // end foreach
        $_GET = $aNew;
      }
    }
  }
  if( isset( $sReturn ) )
    return $sReturn;
} // end function getLinkFromShortLinks

/**
* Returns all short links
* @return array
* @param int $iType
*/
function throwShortLinks( $iType = null ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aShortLinks = $oFFS->getData( DB_LINKS, true );
  if( isset( $aShortLinks ) && is_array( $aShortLinks ) && count( $aShortLinks ) > 0 ){
    if( isset( $iType ) ){
      foreach( $aShortLinks as $sKey => $aValue ){
        if( $iType == $aValue['iType'] && $aValue['sLang'] == LANGUAGE ){
          $aReturn[$aValue['iLink']] = $sKey;
        }
      } // end foreach
      if( isset( $aReturn ) )
        return $aReturn;
    }
    else
      return $aShortLinks;
  }
} // end function throwShortLinks
// END OF PLUGIN LICENSE RESTRICTIONS
?>