<?php
$sValue = (float) phpversion( );
if( $sValue < '5.2' ){
  exit( '<h2><center>REQUIRED PHP VERSION IS 5.2.0, YOU HAVE '.phpversion( ).'</center></h2>' );
}

#error_reporting( E_ALL );

unset( $config, $aMenuTypes, $aPhotoTypes, $lang );

/*
* Set true if logged administrator will be able
* to see hidden pages (in client-side)
*/
$config['hidden_shows'] = false;

/*
* Set true if mobile version will be able
*/
$config['mobile'] = true;

/*
* If mobile browser is detected then redirect to mobile version
*/
$config['detect_mobile'] = true;

/*
* If You want embed PHP code in template files
* set this variable true but it is not recommended and
* script will generate code much slower
*/
$config['embed_php'] = false;

/*
* Add minutes difference between your local time and server time
*/
$config['time_diff'] = 0;

/*
* Administrator login and password
*/
$config['login'] = "admin";
$config['pass'] = "admin";

/*
* Default language
*/
$config['default_lang'] = "en";

/*
* Admin panel language
*/
$config['admin_lang'] = "en";

/*
* If should be use wysiwyg editor or default
*/
$config['wysiwyg'] = true;

/*
* CSS styles file
*/
$config['style'] = "style.css";

/*
* Mobile CSS styles file
*/
$config['style_mobile'] = "mobile.css";

/*
* If should be sorting products option on pages
*/
$config['sorting_products'] = true;

/*
* If customer should recieve on email order details
*/
$config['send_customer_order_details'] = false;

/*
* If should be text size change option on pages
*/
$config['text_size'] = true;

/*
* Display all unavailable options
*/
$config['extended_options'] = true;

/*
* If files should be copied if use the same
*/
$config['copy_the_same_files'] = false;

/*
* Define size of preview image. If you don't want to display preview then set null
*/
$config['image_preview_size'] = 250;

$config['display_all_files'] = true;
$config['display_expanded_menu'] = true;
$config['display_dropdown_menu'] = 1;
$config['change_files_names'] = false;
$config['delete_unused_files'] = true;
$config['inherit_from_parents'] = false;
$config['display_subcategory_products'] = true;
$config['watermark'] = true;
$config['watermark_img'] = "copyrights_small.png";
$config['watermark_dir'] = 'watermark/';

$config['images_sizes'] = array ( 0 => 75, 1 => 150, 2 => 180 );
$config['max_dimension_of_image'] = 900;
$config['display_products_list'] = 1;
$config['mail_encoding_utf8'] = true;
$config['admin_list'] = 25;

$aOuterPaymentOption = Array( 3 => 'PayPal', 9 => 'Transferuj.pl' );

/*
* PayPal account email address
*/
$config['paypal_email'] = "";

/*
* Transferuj.pl account id
*/
$config['transferuj_id'] = "";

$config['before_amp'] = !strstr( $_SERVER['REQUEST_URI'], '?' ) ? '?' : null;

/*
* Set default image size and location
*/
$config['pages_default_image_size_list'] = 1;
$config['pages_default_image_size_details'] = 1;
$config['pages_default_image_location'] = 1;

$config['products_default_image_size_list'] = 1;
$config['products_default_image_size_details'] = 2;
$config['products_default_image_location'] = 1;

/*
* If should be language parameter added to url
*/
$config['language_in_url'] = false;

/*
* Define maximum product quantity in basket
*/
$config['max_product_quantity'] = 100;

/*
* Define maximum product's name letters in admin list
*/
$config['max_product_name_in_list'] = 80;

/*
* Language separator in url
*/
$config['language_separator'] = '_';

define( 'LANGUAGE_IN_URL', $config['language_in_url'] );
define( 'LANGUAGE_SEPARATOR', $config['language_separator'] );

$config['template_editor_extensions'] = 'css|tpl';

/*
* Skin directory
*/
$config['skin'] = "default";

/*
* DONT CHANGE CODE BELOW!
*
* Directories
*/
$config['dir_core'] = 'core/';
$config['dir_database'] = 'database/';
$config['dir_libraries'] = $config['dir_core'].'libraries/';
$config['dir_lang'] = $config['dir_database'].'translations/';
$config['dir_templates'] = 'templates/';
$config['dir_skin'] = $config['dir_templates'].$config['skin'].'/';
$config['dir_files'] = 'files/';
$config['dir_plugins'] = 'plugins/';
$config['dir_actions'] = 'actions/';
$config['dir_themes'] = $config['dir_actions'].'themes/';

require_once $config['dir_core'].'common.php';

$config['cookie_admin'] = defined( 'CUSTOMER_PAGE' ) ? null : 'A';

$config_db['links'] = $config['dir_database'].'links.php';
define( 'DB_LINKS', $config_db['links'] );

require_once $config['dir_core'].'plugins.php';
if( defined( 'CUSTOMER_PAGE' ) && !isset( $p ) && !isset( $sLang ) )
  $sLang = getLinkFromShortLinks( );

if( defined( 'CUSTOMER_PAGE' ) && !isset( $sLang ) && LANGUAGE_IN_URL === true )
  $sLang = getLanguageFromUrl( );

if( isset( $sLang ) && is_file( $config['dir_lang'].$sLang.'.php' ) && strlen( $sLang ) == 2 ){
  setCookie( 'sLanguage'.$config['cookie_admin'], $sLang, time( ) + 86400 );
  define( 'LANGUAGE', $sLang );
}
else{
  if( !empty( $_COOKIE['sLanguage'.$config['cookie_admin']] ) && is_file( $config['dir_lang'].$_COOKIE['sLanguage'.$config['cookie_admin']].'.php' ) && strlen( $_COOKIE['sLanguage'.$config['cookie_admin']] ) == 2 )
    define( 'LANGUAGE', $_COOKIE['sLanguage'.$config['cookie_admin']] );
  else
    define( 'LANGUAGE', $config['default_lang'] );
}

require_once defined( 'CUSTOMER_PAGE' ) ? $config['dir_lang'].LANGUAGE.'.php' : $config['dir_lang'].$config['admin_lang'].'.php';

$aMenuTypes = Array( 1 => $lang['Menu_1'], 2 => $lang['Menu_2'], 3 => $lang['Menu_3'], 4 => $lang['Menu_4'] );
$aPhotoTypes = Array( 1 => $lang['Left'], 2 => $lang['Right'] );

$config['config'] = $config['dir_database'].'config/general.php';
$config['config_lang'] = $config['dir_database'].'config/lang_'.LANGUAGE.'.php';

$config['upgrade_file'] = "http://opensolution.org/download/Quick.Cart/bugFixes.php";
$config['upgrade_link'] = "http://opensolution.org/download/Quick.Cart/bugFixes.html";

$config_db['pages'] = $config['dir_database'].LANGUAGE.'_pages.php';
$config_db['pages_files'] = $config['dir_database'].LANGUAGE.'_pages_files.php';
$config_db['products'] = $config['dir_database'].LANGUAGE.'_products.php';
$config_db['products_pages'] = $config['dir_database'].LANGUAGE.'_products_pages.php';
$config_db['products_files'] = $config['dir_database'].LANGUAGE.'_products_files.php';
$config_db['payments_shipping'] = $config['dir_database'].LANGUAGE.'_payments_shipping.php';
$config_db['orders_temp'] = $config['dir_database'].'orders_temp.php';
$config_db['orders'] = $config['dir_database'].'orders.php';
$config_db['orders_products'] = $config['dir_database'].'orders_products.php';
$config_db['orders_ext'] = $config['dir_database'].'orders_ext.php';
$config_db['counter'] = $config['dir_database'].'counter.php';

$config['disable_agents'] = 'robot|spider|crawler|curl|google'; // robots that are disabled

$config['language'] = LANGUAGE;
$config['version'] = '5.2';

$config['last_login'] = 1346391697;
$config['before_last_login'] = 1346312544;
$config['failed_login_time'] = 0;
$config['failed_login_count'] = 0;

$config['default_theme'] = "default.php";
$config['default_pages_template'] = "pages_default.tpl";
$config['default_products_template'] = "products_default.tpl";

$config['manual_link'] = 'http://opensolution.org/Quick.Cart/docs/?id='.( ( $config['admin_lang']=='pl' ) ? 'pl' : 'en' ).'-';

define( 'DIR_CORE', $config['dir_core'] );
define( 'DIR_DATABASE', $config['dir_database'] );
define( 'DIR_FILES', $config['dir_files'] );
define( 'DIR_LIBRARIES', $config['dir_libraries'] );
define( 'DIR_PLUGINS', $config['dir_plugins'] );
define( 'DIR_LANG', $config['dir_lang'] );
define( 'DIR_TEMPLATES', $config['dir_templates'] );
define( 'DIR_SKIN', $config['dir_skin'] );
define( 'DIR_THEMES', $config['dir_themes'] );
define( 'DIR_ACTIONS', $config['dir_actions'] );

define( 'DB_PAGES', $config_db['pages'] );
define( 'DB_PAGES_FILES', $config_db['pages_files'] );
define( 'DB_PRODUCTS', $config_db['products'] );
define( 'DB_PRODUCTS_FILES', $config_db['products_files'] );
define( 'DB_PRODUCTS_PAGES', $config_db['products_pages'] );
define( 'DB_PAYMENTS_SHIPPING', $config_db['payments_shipping'] );
define( 'DB_ORDERS_TEMP', $config_db['orders_temp'] );
define( 'DB_ORDERS', $config_db['orders'] );
define( 'DB_ORDERS_PRODUCTS', $config_db['orders_products'] );
define( 'DB_ORDERS_EXT', $config_db['orders_ext'] );
define( 'DB_COUNTER', $config_db['counter'] );

define( 'DB_CONFIG', $config['config'] );
define( 'DB_CONFIG_LANG', $config['config_lang'] );

define( 'MAX_DIMENSION_OF_IMAGE', $config['max_dimension_of_image'] );
define( 'HIDDEN_SHOWS', $config['hidden_shows'] );
define( 'DISPLAY_EXPANDED_MENU', $config['display_expanded_menu'] );
define( 'WYSIWYG', $config['wysiwyg'] );
define( 'COPY_THE_SAME_FILES', $config['copy_the_same_files'] );
define( 'VERSION', $config['version'] );
define( 'TIME_DIFF', $config['time_diff'] );
define( 'SESSION_KEY_NAME', md5( dirname( $_SERVER['SCRIPT_FILENAME'] ) ) );
define( 'DISPLAY_SUBCATEGORY_PRODUCTS', $config['display_subcategory_products'] );

define( 'DIR_WATERMARK', DIR_FILES.$config['watermark_dir'] );
define( 'DIR_RAW_IMAGES', DIR_WATERMARK.'raw_images/' );
define( 'WATERMARK_IMG', DIR_WATERMARK.$config['watermark_img'] );
?>